<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGetSymbols ArrayType
 * @subpackage Arrays
 */
class ArrayOfGetSymbols extends AbstractStructArrayBase
{
    /**
     * The GetSymbols
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetSymbols[]
     */
    public $GetSymbols;
    /**
     * Constructor method for ArrayOfGetSymbols
     * @uses ArrayOfGetSymbols::setGetSymbols()
     * @param \StructType\GetSymbols[] $getSymbols
     */
    public function __construct(array $getSymbols = array())
    {
        $this
            ->setGetSymbols($getSymbols);
    }
    /**
     * Get GetSymbols value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetSymbols[]|null
     */
    public function getGetSymbols()
    {
        return isset($this->GetSymbols) ? $this->GetSymbols : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGetSymbols method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetSymbols method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGetSymbolsForArrayConstraintsFromSetGetSymbols(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGetSymbolsGetSymbolsItem) {
            // validation for constraint: itemType
            if (!$arrayOfGetSymbolsGetSymbolsItem instanceof \StructType\GetSymbols) {
                $invalidValues[] = is_object($arrayOfGetSymbolsGetSymbolsItem) ? get_class($arrayOfGetSymbolsGetSymbolsItem) : sprintf('%s(%s)', gettype($arrayOfGetSymbolsGetSymbolsItem), var_export($arrayOfGetSymbolsGetSymbolsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GetSymbols property can only contain items of type \StructType\GetSymbols, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GetSymbols value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GetSymbols[] $getSymbols
     * @return \ArrayType\ArrayOfGetSymbols
     */
    public function setGetSymbols(array $getSymbols = array())
    {
        // validation for constraint: array
        if ('' !== ($getSymbolsArrayErrorMessage = self::validateGetSymbolsForArrayConstraintsFromSetGetSymbols($getSymbols))) {
            throw new \InvalidArgumentException($getSymbolsArrayErrorMessage, __LINE__);
        }
        if (is_null($getSymbols) || (is_array($getSymbols) && empty($getSymbols))) {
            unset($this->GetSymbols);
        } else {
            $this->GetSymbols = $getSymbols;
        }
        return $this;
    }
    /**
     * Add item to GetSymbols value
     * @throws \InvalidArgumentException
     * @param \StructType\GetSymbols $item
     * @return \ArrayType\ArrayOfGetSymbols
     */
    public function addToGetSymbols(\StructType\GetSymbols $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GetSymbols) {
            throw new \InvalidArgumentException(sprintf('The GetSymbols property can only contain items of type \StructType\GetSymbols, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GetSymbols[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GetSymbols|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GetSymbols|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GetSymbols|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GetSymbols|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GetSymbols|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GetSymbols
     */
    public function getAttributeName()
    {
        return 'GetSymbols';
    }
}
