<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGetTodayOrders ArrayType
 * @subpackage Arrays
 */
class ArrayOfGetTodayOrders extends AbstractStructArrayBase
{
    /**
     * The GetTodayOrders
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetTodayOrders[]
     */
    public $GetTodayOrders;
    /**
     * Constructor method for ArrayOfGetTodayOrders
     * @uses ArrayOfGetTodayOrders::setGetTodayOrders()
     * @param \StructType\GetTodayOrders[] $getTodayOrders
     */
    public function __construct(array $getTodayOrders = array())
    {
        $this
            ->setGetTodayOrders($getTodayOrders);
    }
    /**
     * Get GetTodayOrders value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetTodayOrders[]|null
     */
    public function getGetTodayOrders()
    {
        return isset($this->GetTodayOrders) ? $this->GetTodayOrders : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGetTodayOrders method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetTodayOrders method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGetTodayOrdersForArrayConstraintsFromSetGetTodayOrders(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGetTodayOrdersGetTodayOrdersItem) {
            // validation for constraint: itemType
            if (!$arrayOfGetTodayOrdersGetTodayOrdersItem instanceof \StructType\GetTodayOrders) {
                $invalidValues[] = is_object($arrayOfGetTodayOrdersGetTodayOrdersItem) ? get_class($arrayOfGetTodayOrdersGetTodayOrdersItem) : sprintf('%s(%s)', gettype($arrayOfGetTodayOrdersGetTodayOrdersItem), var_export($arrayOfGetTodayOrdersGetTodayOrdersItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GetTodayOrders property can only contain items of type \StructType\GetTodayOrders, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GetTodayOrders value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GetTodayOrders[] $getTodayOrders
     * @return \ArrayType\ArrayOfGetTodayOrders
     */
    public function setGetTodayOrders(array $getTodayOrders = array())
    {
        // validation for constraint: array
        if ('' !== ($getTodayOrdersArrayErrorMessage = self::validateGetTodayOrdersForArrayConstraintsFromSetGetTodayOrders($getTodayOrders))) {
            throw new \InvalidArgumentException($getTodayOrdersArrayErrorMessage, __LINE__);
        }
        if (is_null($getTodayOrders) || (is_array($getTodayOrders) && empty($getTodayOrders))) {
            unset($this->GetTodayOrders);
        } else {
            $this->GetTodayOrders = $getTodayOrders;
        }
        return $this;
    }
    /**
     * Add item to GetTodayOrders value
     * @throws \InvalidArgumentException
     * @param \StructType\GetTodayOrders $item
     * @return \ArrayType\ArrayOfGetTodayOrders
     */
    public function addToGetTodayOrders(\StructType\GetTodayOrders $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GetTodayOrders) {
            throw new \InvalidArgumentException(sprintf('The GetTodayOrders property can only contain items of type \StructType\GetTodayOrders, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GetTodayOrders[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GetTodayOrders|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GetTodayOrders|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GetTodayOrders|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GetTodayOrders|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GetTodayOrders|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GetTodayOrders
     */
    public function getAttributeName()
    {
        return 'GetTodayOrders';
    }
}
